Subject: Re: [PATCH net] net: mvpp2: Enable autoneg bypass for 1000BaseX/2500BaseX ports

From: Russell King - ARM Linux admin <[email-masked]>
Date: Thu, 28 May 2020 14:56:08 +0100

On Thu, May 28, 2020 at 03:17:33PM +0200, Thomas Bogendoerfer wrote:
> On Thu, 28 May 2020 14:07:38 +0100
> Russell King - ARM Linux admin <[email-masked]> wrote:
> 
> > On Thu, May 28, 2020 at 02:11:21PM +0200, Thomas Bogendoerfer wrote:
> > > Commit d14e078f23cc ("net: marvell: mvpp2: only reprogram what is necessary
> > >  on mac_config") disabled auto negotiation bypass completely, which breaks
> > > platforms enabling bypass via firmware (not the best option, but it worked).
> > > Since 1000BaseX/2500BaseX ports neither negotiate speed nor duplex mode
> > > we could enable auto negotiation bypass to get back information about link
> > > state.
> > 
> > Thanks, but your commit is missing some useful information.
> > 
> > Which platforms have broken?
> 
> it's an Ambedded MARS-400
>  
> > Can you describe the situation where you require this bit to be set?
> 
> as I have no exact design details I'm just talking about what I can see
> on that platform. It looks like the switch connecting the internal nodes
> doesn't run autoneg on the internal links. So the link to the internal
> nodes will never come up. These links are running 2500BaseX so speed/duplex
> is clean and by enabling bypass I'll get a proper link state, too.
> 
> > We should not be enabling bypass mode as a matter of course, it exists
> > to work around broken setups which do not send the control word.
> 
> if you call it a broken setup I'm fine, but this doesn't solve the problem,
> which exists now. What would be your solution ?

What I was after was additional information about the problem, so
that we can start thinking about how to deal with the AN bypass bit
in a sensible way.

How is the connection between the switch and network interface
described?  I don't think I see a .dts file in mainline for this
platform.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTC for 0.8m (est. 1762m) line in suburbia: sync at 13.1Mbps down 424kbps up